#include <Adafruit_SSD1306.h>
#include <Adafruit_GFX.h>
#include <Adafruit_DHT.h>
#include <Wire.h>

#define OLED_ADDR   0x3C
#define DHTPIN      2
#define DHTTYPE     DHT20

Adafruit_SSD1306 display(128, 32, &Wire, -1);
DHT dht(DHTPIN, DHTTYPE);

void setup() {
  Wire.begin();
  display.begin(SSD1306_SWITCHCAPVCC, OLED_ADDR);
  display.clearDisplay();
  display.display();
  dht.begin();
}

void loop() {
  float humidity = dht.readHumidity();
  float temperature = dht.readTemperature();
  if (isnan(humidity) || isnan(temperature)) {
    display.println("Failed to read data from DHT20");
    display.display();
    delay(2000);
    return;
  }

  display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(SSD1306_WHITE);
  display.setCursor(0, 0);
  display.println("Temperature: " + String(temperature) + "C");
  display.println("Humidity: " + String(humidity) + "%");
  display.display();
  delay(2000);